#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#define NPAGES		16
#define MMAP_DEV	"/dev/mymmap"

int main(void)
{
	int fd;
	unsigned char *addr;
	int len = NPAGES * getpagesize();
	int i;

	assert(system("mknod " MMAP_DEV " c 42 0") == 0);

	fd = open(MMAP_DEV, O_RDWR | O_SYNC);
	if (fd < 0) {
		perror("open");
		assert(system("rm " MMAP_DEV) == 0);
		exit(EXIT_FAILURE);
	}

	addr = mmap(NULL, len, PROT_READ, MAP_SHARED, fd, 0);
	if (addr == MAP_FAILED) {
		perror("mmap");
		assert(system("rm " MMAP_DEV) == 0);
		exit(EXIT_FAILURE);
	}

	for (i = 0; i < NPAGES * getpagesize(); i += getpagesize()) {
		if (addr[i] != 'a' || addr[i + 1] != 'a' ||
				addr[i + 2] != 'a' || addr[i + 3] != 'a')
			printf("0x%x 0x%x 0x%x 0x%x\n", addr[i], addr[i+1],
					addr[i+2], addr[i+3]);
		else
			printf("matched\n");
	}

	close(fd);

	assert(system("rm " MMAP_DEV) == 0);

	return 0;
}
