/*
 * Shamelessly copied from
 * http://binwaheed.blogspot.ro/2010/08/after-reading-kernel-source-i-finally.html
 */

#include <linux/module.h>
#include <net/sock.h>
#include <linux/netlink.h>
#include <linux/skbuff.h>

MODULE_DESCRIPTION("Netlink communication module");
MODULE_AUTHOR("binwaheed, razvand");
MODULE_LICENSE("GPL");

#define NETLINK_USER		31
#define LOG_LEVEL		KERN_ALERT

/* kernel-side netlink socket */
static struct sock *nl_sk;

static void hello_nl_recv_msg(struct sk_buff *skb)
{
	struct nlmsghdr *nlh;

	printk(LOG_LEVEL "Entering: %s\n", __FUNCTION__);

	nlh = (struct nlmsghdr *) skb->data;
	printk(LOG_LEVEL "Netlink received msg payload (%s) from process %d\n",
			(char *) nlmsg_data(nlh), nlh->nlmsg_pid);
}

static struct netlink_kernel_cfg hello_cfg = {
	.groups = 1,
	.input = hello_nl_recv_msg,
};

static int __init hello_init(void)
{
	printk(LOG_LEVEL "Entering: %s\n", __FUNCTION__);

	nl_sk = netlink_kernel_create(&init_net, NETLINK_USER, &hello_cfg);
	if (!nl_sk) {
		printk(KERN_ALERT "Error creating socket.\n");
		return -ENOMEM;
	}

	return 0;
}

static void __exit hello_exit(void)
{
	printk(LOG_LEVEL "Exiting hello module\n");
	netlink_kernel_release(nl_sk);
}

module_init(hello_init);
module_exit(hello_exit);
