/*
 * Shameless copied from:
 * http://binwaheed.blogspot.ro/2010/08/after-reading-kernel-source-i-finally.html
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/netlink.h>

#define NETLINK_USER		31

#define MAX_PAYLOAD		1024  /* maximum payload size*/
#define MESSAGE_TO_SEND		"Hello, netlink!"

int main(void)
{
	struct sockaddr_nl src_addr, dest_addr;
	struct nlmsghdr *nlh = NULL;
	struct iovec iov;
	struct msghdr msg;
	int sock_fd;
	int rc;

	sock_fd = socket(PF_NETLINK, SOCK_RAW, NETLINK_USER);
	if(sock_fd < 0) {
		perror("socket");
		exit(EXIT_FAILURE);
	}

	/* Use current process as "source endpoint". */
	memset(&src_addr, 0, sizeof(src_addr));
	src_addr.nl_family = AF_NETLINK;
	src_addr.nl_pid = getpid();  /* self pid */
	bind(sock_fd, (struct sockaddr *)&src_addr, sizeof(src_addr));

	/* Use kernel as destination endpoint. */
	memset(&dest_addr, 0, sizeof(dest_addr));
	dest_addr.nl_family = AF_NETLINK;
	dest_addr.nl_pid = 0;   /* For Linux Kernel */
	dest_addr.nl_groups = 0; /* unicast */

	/* Construct message to send. */
	nlh = (struct nlmsghdr *) malloc(NLMSG_SPACE(MAX_PAYLOAD));
	memset(nlh, 0, NLMSG_SPACE(MAX_PAYLOAD));
	nlh->nlmsg_len = NLMSG_SPACE(MAX_PAYLOAD);
	nlh->nlmsg_pid = getpid();
	strcpy(NLMSG_DATA(nlh), MESSAGE_TO_SEND);

	memset(&iov, 0, sizeof(iov));
	iov.iov_base = nlh;
	iov.iov_len = nlh->nlmsg_len;
	memset(&msg, 0, sizeof(msg));
	msg.msg_name = &dest_addr;
	msg.msg_namelen = sizeof(dest_addr);
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;

	printf("Sending message to kernel\n");
	rc = sendmsg(sock_fd, &msg, 0);
	if (rc < 0) {
		perror("recvmsg");
		exit(EXIT_FAILURE);
	}

	close(sock_fd);

	return 0;
}
