/**
  * Use ioctl calls on CD-ROM drive.
  *
  * Heavily inspired by eject source code: http://eject.sourceforge.net/
  * Documentation in Documentation/ioctl/cdrom.txt in Linux source code.
  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/cdrom.h>

#include "utils.h"

#define CDROM_DEV_PATH		"/dev/sr0"

int main(void)
{
	int fd;
	int rc;

	fd = open(CDROM_DEV_PATH, O_RDONLY | O_NONBLOCK);
	DIE(fd < 0, "open");

	rc = ioctl(fd, CDROMEJECT);
	DIE(rc < 0, "ioctl");

	close(fd);
	return 0;
}
